﻿using BolapanControl.ItemsFilter.Initializer;
using BolapanControl.ItemsFilter.Model;
using OuDot.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OuDot.RozsireniGrafika
{
    #region Filtry Externi Zdroje

    #region Platnost Od
    public class ExtSloupecPlatnostOdFIM : FilterInitializersManager
    {
        public ExtSloupecPlatnostOdFIM()
        {
            Add(new PlatnostOdFilterInitializer());
        }
    }

   
    //class PlatnostOdStringFilterInitializer : FilterInitializer
    //{
    //    public override Filter NewFilter(BolapanControl.ItemsFilter.FilterPresenter filterPresenter, object key)
    //    {
    //        if (key is string && (string)key == "EXT_TABULKY.PLATNOST_OD")
    //        {
    //            return new PlatnostOdStringFilter();
    //        }
    //        return null;
    //    }
    //}

    
    //public sealed class PlatnostOdStringFilter : BolapanControl.ItemsFilter.Model.StringFilter//, BolapanControl.ItemsFilter.Model.IFilter
    //{

    //    public PlatnostOdStringFilter() : base(PlatnostOdGetter)
    //    {

    //    }
    //    private static string PlatnostOdGetter(object val)
    //    {
    //        return ((EXT_SLOUPCE)val).EXT_TABULKY.PLATNOST_OD.ToString("dd.MM.yyyy");
    //    }
    //}


    class PlatnostOdFilterInitializer : FilterInitializer
    {
        public override Filter NewFilter(BolapanControl.ItemsFilter.FilterPresenter filterPresenter, object key)
        {
            if (key is string && (string)key == "EXT_TABULKY.PLATNOST_OD")
            {
                return new PlatnostOdRangeFilter();
            }
            return null;
        }
    }

    public sealed class PlatnostOdRangeFilter : BolapanControl.ItemsFilter.Model.RangeFilter<DateTime>//, BolapanControl.ItemsFilter.Model.IFilter
    {

        public PlatnostOdRangeFilter() : base(PlatnostOdGetter)
        {

        }
        private static DateTime PlatnostOdGetter(object val)
        {
            return ((EXT_SLOUPCE)val).EXT_TABULKY.PLATNOST_OD;//.ToString("dd.MM.yyyy");
        }
    }

    #endregion Platnost Od

    #region Platnost Do

    public class ExtSloupecPlatnostDoFIM : FilterInitializersManager
    {
        public ExtSloupecPlatnostDoFIM()
        {
            Add(new PlatnostDoFilterInitializer());
        }
    }

    

    class PlatnostDoFilterInitializer : FilterInitializer
    {
        public override Filter NewFilter(BolapanControl.ItemsFilter.FilterPresenter filterPresenter, object key)
        {
            if (key is string && (string)key == "EXT_TABULKY.PLATNOST_DO")
            {
                return new PlatnostDoRangeFilter();
            }
            return null;
        }
    }

    public sealed class PlatnostDoRangeFilter : BolapanControl.ItemsFilter.Model.RangeFilter<DateTime>//, BolapanControl.ItemsFilter.Model.IFilter
    {

        public PlatnostDoRangeFilter() : base(PlatnostOdGetter)
        {

        }
        private static DateTime PlatnostOdGetter(object val)
        {

            return ((EXT_SLOUPCE)val).EXT_TABULKY.PLATNOST_DO ?? new DateTime(9999, 1, 1);//.ToString("dd.MM.yyyy");
        }
    }

    #endregion Platnost Do

    #endregion Filtry Externi Zdroje
}
