﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OuDot.ServicesOudot
{
    /// <summary>
    /// Popisuje validační chybu
    /// </summary>
    public class ValidacniChyba
    {
        /// <summary>
        /// Text chyby
        /// </summary>
        public string Chyba { get; set; }
        /// <summary>
        /// Název třídy objektu na kterém chyba nastala
        /// </summary>
        public string TypObjektu { get; set; }
        /// <summary>
        /// Objekt s validační chybou
        /// </summary>
        public object Objekt { get; set; }
        /// <summary>
        /// Objekt, který slouží k zobrazení okna na kterém se chyba vyskytuje
        /// </summary>
        public object DataContextOknaChyby { get; set; }
        /// <summary>
        /// Název chybné property objektu
        /// </summary>
        public string ChybnaProperty { get; set; }

        public ValidacniChyba(string chybovaHlaska, string nazevObjektu, object obj, string nazevProprty, object objektVizualizace)
        {
            Chyba = chybovaHlaska;
            TypObjektu = nazevObjektu;
            Objekt = obj;
            ChybnaProperty = nazevProprty;
            DataContextOknaChyby = objektVizualizace;

            
        }

    }
}
