﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using OuDot.Model;
using OuDot.ServicesOudot;

namespace OuDot.ViewModel.IporterWizzard
{
    /// <summary>
    /// Interaction logic for ImporterWindow.xaml
    /// </summary>
    public partial class ImporterWindow : Window
    {
        public ImporterWindow()
        {
            InitializeComponent();
            this.DataContext = ImporterViewModel.Instance;
        }

        private void dpPlatnostOd_SelectedDateChanged(object sender, SelectionChangedEventArgs e)
        {
            if (this.dpPlatnostDo != null)//Při změně, spustí validace na druhém datepickeru
                this.dpPlatnostDo.GetBindingExpression(DatePicker.SelectedDateProperty).UpdateSource();
        }

        private void dpPlatnostDo_SelectedDateChanged(object sender, SelectionChangedEventArgs e)
        {
            if (this.dpPlatnostOd != null)//Při změně, spustí validace na druhém datepickeru
                this.dpPlatnostOd.GetBindingExpression(DatePicker.SelectedDateProperty).UpdateSource();
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {

            if(ImporterViewModel.Instance.IsBusy)
            {
                e.Cancel = true;
            }
            //Zjistím zda není rozpracovaná nějaká externí tabulka a pokud ano vymažu ji z DB contextu a tím se smažou i chybné validace
            EXT_TABULKY vmTab= (this.DataContext as ImporterViewModel).ExtTabulka;
            if (vmTab != null)
            {
                DBContext.Instance.Entity.EXT_TABULKY.Remove(vmTab);
                (this.DataContext as ImporterViewModel).ExtTabulka = null;
            }
        }

        
    }
}
