﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace OuDot.ViewModel
{
    /// <summary>
    /// Interaction logic for OProgramuWindow.xaml
    /// </summary>
    public partial class OProgramuWindow : Window
    {
        public OProgramuWindow()
        {
            InitializeComponent();

            Version av = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
            this.Verze.Text = av.ToString();
            DateTime dt = new DateTime(2000, 1, 1, 0, 0, 0).AddDays(av.Build).AddSeconds(av.Revision * 2);
            if (TimeZone.IsDaylightSavingTime(dt, TimeZone.CurrentTimeZone.GetDaylightChanges(dt.Year)))
                dt = dt.AddHours(1);
            this.DatumVerze.Text = dt.ToString("d.M.yyyy");
        }

        private void OnNavigate(object sender, RequestNavigateEventArgs e)
        {
            Process.Start(e.Uri.AbsoluteUri);
            e.Handled = true;
        }
    }
}
