﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using OuDot.Model;

namespace OuDot.ViewModel.PomocnaOkna
{
    /// <summary>
    /// Interaction logic for KlonovatWindow.xaml
    /// </summary>
    public partial class KlonovatOUWindow : Window
    {
        public KlonovatOUWindow(ObservableCollection<OU_TAB> KolekceTabulek, OU_TAB VybranaTabulka)
        {
            InitializeComponent();

            this.cbTabulka.ItemsSource = KolekceTabulek;
            this.cbTabulka.SelectedItem = VybranaTabulka;
        }

        private void bOK_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            this.Close();
        }
    }
}
